/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { AttachState } from "@fluidframework/container-definitions";
import { IRequest, IResponse } from "@fluidframework/core-interfaces";
import { IFluidHandleContext } from "@fluidframework/core-interfaces/internal";
export interface IContainerHandleContextRuntime {
    attachState: AttachState;
    resolveHandle(request: IRequest): Promise<IResponse>;
}
export declare class ContainerFluidHandleContext implements IFluidHandleContext {
    readonly path: string;
    private readonly runtime;
    readonly routeContext?: IFluidHandleContext | undefined;
    get IFluidHandleContext(): IFluidHandleContext;
    readonly absolutePath: string;
    /**
     * Creates a new ContainerFluidHandleContext.
     * @param path - The path to this handle relative to the routeContext.
     * @param runtime - The IRuntime object this context represents.
     * @param routeContext - The parent IFluidHandleContext that has a route to this handle.
     */
    constructor(path: string, runtime: IContainerHandleContextRuntime, routeContext?: IFluidHandleContext | undefined);
    attachGraph(): void;
    get isAttached(): boolean;
    resolveHandle(request: IRequest): Promise<IResponse>;
}
//# sourceMappingURL=containerHandleContext.d.ts.map