/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { AttachState, type IContainerContext } from "@fluidframework/container-definitions/internal";
import type { ISummaryTreeWithStats } from "@fluidframework/runtime-definitions/internal";
import type { ITelemetryLoggerExt } from "@fluidframework/telemetry-utils/internal";
/**
 * Information from a snapshot needed to load BlobManager
 * @legacy
 * @alpha
 */
export interface IBlobManagerLoadInfo {
    ids?: string[];
    redirectTable?: [string, string][];
}
export declare const redirectTableBlobName = ".redirectTable";
/**
 * @internal
 */
export declare const blobsTreeName = ".blobs";
/**
 * Reads blobs needed to load BlobManager from storage.
 *
 */
export declare const loadBlobManagerLoadInfo: (context: Pick<IContainerContext, "baseSnapshot" | "storage" | "attachState">) => Promise<IBlobManagerLoadInfo>;
export declare const toRedirectTable: (snapshot: IBlobManagerLoadInfo, logger: ITelemetryLoggerExt, attachState: AttachState) => Map<string, string | undefined>;
export declare const summarizeBlobManagerState: (redirectTable: Map<string, string | undefined>, attachState: AttachState) => ISummaryTreeWithStats;
export declare const getStorageIds: (redirectTable: Map<string, string | undefined>, attachState: AttachState) => Set<string>;
//# sourceMappingURL=blobManagerSnapSum.d.ts.map